! AnnualCycle_v2.f90
! April 6, 2005
! This Program Computes the Daily Annual Cycle of ppt, snw, tmax, tmin, and qw Data
! The Data Type As Above Must Be In The Filename
! Uses Floating Point Numbers 
! Missing Values are Ignored. Leap Years are Used 
! The Annual Cycle is Computed Using the Entire Time Series
! Version AnnualCycle_v2.f90 Modified For Batch File Processing
! April 6, 2006 Lines 72, 73, and 79 Corrected Data Type Name    
!
PROGRAM AnnualCycle_v2
IMPLICIT NONE
!
CHARACTER :: BatchFileName*120, BatchFileIn*120,BatchFileOut*120, &
             & DirectoryIn*120,DirectoryOut*120, BatchAnswer*1 !Variables Reserved for Batch File
CHARACTER :: FileNameIn*120, FileNameOut*120
CHARACTER :: Answer*1, BeginDate*10, EndDate*10, DataIn*26, First*10, Last*10
CHARACTER :: DataDate(57488)*10, Date_Str(366)*5, DateTmp*10
     REAL :: Avg(366), Maximum (366), Minimum(366), StdDev(366)
	 REAL :: DataOut(57488)
     REAL :: NDays, Sum, Sum_of_Squares, PercentMissing, Xplot
     REAL :: DayValueTmp 
  INTEGER :: OpenStatus, OpenStatus1, PositionPpt, PositionQw, PositionSnw, PositionTmax, &
             & PositionTmin, InputStatus,InputStatus1, NumberLines, &
			 & AllocateStatus, BatchFileNumber, I, J, K
  INTEGER :: ValidN(366), Missing(366), PptDays(366)
!
! **********************************************************************************
!
! User Input
! Data Entry and File Names
!
1 WRITE (*,*) "Process a single file or multiple files ?"
  WRITE (*,*) "s = single file"
  WRITE (*,*) "m = multiple files"
	READ (*,*) BatchAnswer

IF (BatchAnswer=="s" .OR. BatchAnswer=="S") GOTO 10
IF (BatchAnswer=="m" .OR. BatchAnswer=="m") GOTO 9
! File Input for Batch Processing ! ***********************************************

9 WRITE (*,*) "Enter path and name of batch processing file"
		READ (*,*) BatchFileName
		WRITE(*,*)
WRITE (*,*) "Enter number of files to process"
		READ (*,*) BatchFileNumber
        WRITE(*,*)
WRITE (*,*) "Enter drive letter and directory of input files"
		READ (*,*)DirectoryIn 
		WRITE(*,*)
WRITE (*,*) "Enter drive letter and directory of output files"
		READ (*,*)DirectoryOut
		WRITE(*,*)

OPEN (UNIT=11,FILE=BatchFileName, STATUS="OLD", POSITION="REWIND", &
         ERR=9, IOSTAT=OpenStatus1)

Batch_Input_Loop:DO J=1,BatchFileNumber
!
     READ (UNIT=11, FMT=7,IOSTAT=InputStatus1) BatchFileIn,BatchFileOut,First,Last, &
      PercentMissing,Xplot   
		IF (InputStatus1 > 0) STOP "Input Error"
			IF (InputStatus1 < 0) EXIT !"End of File"
	7 FORMAT (A24, 1X, A24, 1X, A10, X, A10, X, F2.0, X, F4.0)
	 FileNameIn=TRIM(DirectoryIn)//"\"//BatchFileIn
	FileNameOut=TRIM(DirectoryOut)//"\"//BatchFileOut
        WRITE (*,*)"Processing: ", FileNameIn
     
        PositionPpt=INDEX (FileNameIn, "ppt")
        PositionSnw=INDEX (FileNameIn, "snw")
         PositionQw=INDEX (FileNameIn, "qw")
       PositionTmin=INDEX(FileNameIn, "tmin")
       PositionTmax=INDEX(FileNameIn, "tmax")

	CALL SetUpData

	CALL Calendar_Dates (Date_Str)

    CALL DayStatistics

! Open and Prepare to Write Output Files

OPEN (UNIT=10,FILE=FileNameOut, STATUS="NEW", ACTION="WRITE",POSITION="REWIND", &
IOSTAT=OpenStatus)
	IF (OpenStatus > 0) STOP "Cannot Open File"
!
                            IF (PositionPpt>0 .OR. PositionSnw>0) CALL PptOutput
                                                IF (PositionQw>0) CALL QwOutput  
     IF (PositionPpt==0 .AND. PositionSnw==0 .AND. PositionQw==0) CALL TemperatureOutput
!
CLOSE(UNIT=10)
!
END DO Batch_Input_Loop ! **************************************************************************

CLOSE (UNIT=11)

GOTO 12
!
! Single File Data Entry ***************************************************************************


10 WRITE (*,*) "Enter Name of Data File to Process"
  	READ (*,*) FileNameIn
   WRITE(*,*)

WRITE (*,*) "Enter Output File Name"
	READ (*,*) FileNameOut
WRITE (*,*)

 PositionPpt=INDEX(FileNameIn, "ppt") 
									
 PositionSnw=INDEX(FileNameIn, "snw")

PositionTmax=INDEX(FileNameIn, "tmax")

PositionTmin=INDEX(FileNameIn, "tmin")

  PositionQw=INDEX(FileNameIn, "qw")
!
CALL SetUpData
!
CALL Calendar_Dates (Date_Str) ! *********************************************************
!
CALL DayStatistics
!
   IF (PositionPpt>0 .OR. PositionSnw>0) CALL PptOutput

IF (PositionTmax>0 .OR. PositionTmin >0) CALL TemperatureOutput

                       IF (PositionQw>0) CALL QwOutput
!
12	WRITE (*,*) "Process more data Y/N"
		READ (*,*) Answer
		IF (Answer=="Y".OR. Answer=="y") GOTO 1
		
	WRITE (*,*)
!
! *********************************************************************************
!	
CONTAINS ! *******************************************************************************
!
!
SUBROUTINE SetUpData ! ******************************************************************
IMPLICIT NONE
! Read Data From FilenameIn
!
OPEN (UNIT=10,FILE=FileNameIn, STATUS="OLD", ACTION="READ", &
	POSITION="REWIND",IOSTAT=OpenStatus)
NumberLines=0
!
DO I=1, 54788
	READ(UNIT=10, FMT=30, IOSTAT=InputStatus) DataIn
		IF (InputStatus > 0) STOP "Input Error"
			IF (InputStatus < 0) EXIT !End of File
30 FORMAT (A26)
    DateTmp=DataIn(1:10)
	DataDate(I)=DateTmp
!
!Convert Data to Real
!
	IF (DataIn(14:26)=="T") DataIn(14:26)="0" !Change T(race) to 0
	READ (DataIn(12:26),*) DayValueTmp
40 FORMAT(F12.2)
		DataOut(I)=DayValueTmp
	   NumberLines=NumberLines+1
!write (*,*) DataDate(I), DataOut(I)   			
END DO 
!
CLOSE (UNIT=10)
!
BeginDate=DataDate(1)(1:10)
EndDate=DataDate(NumberLines)(1:10)
!
END SUBROUTINE SetUpData
!
!Create 366 Calendar Dates (01/01 to 12/31) 
!
SUBROUTINE Calendar_Dates (string)! ******************************************************
IMPLICIT NONE
!
CHARACTER (2) :: Day_Str, Month_Str
CHARACTER, INTENT(OUT) :: string(366)*5
INTEGER :: J, Number_of_Days, Day, MthDays

Number_of_Days=0
DO J=1,12
		WRITE (Month_Str,'(I2)') J
			IF (J<10) Month_Str(1:1)="0"
	!Select number of days in month J
		Days_in_Month: SELECT CASE (J)
		CASE (2)
			MthDays=29
		CASE (4)
			MthDays=30
		CASE (6)
			MthDays=30
		CASE (9)
			MthDays=30
		CASE (11)
			MthDays=30
		CASE DEFAULT
			MthDays=31
		END SELECT Days_in_Month
			 DO Day=1, MthDays
			Number_of_Days=Number_of_Days+1
			WRITE (Day_Str,'(I2)') Day
			IF (Day<10) Day_Str(1:1)="0"
				string(Number_of_Days)(1:5)=Month_Str//"/"//Day_Str				
			END DO
!write(*,*) string
END DO

END SUBROUTINE Calendar_Dates ! **************************************************************
!
!
SUBROUTINE DayStatistics ! *******************************************************************
IMPLICIT NONE
!
! Calculate Statistics for Each Calendar Date From 01/01 to 12/31
!
Minimum=50000
Maximum=-200
DO I=1, 366
               Sum=0
	Sum_of_Squares=0
	    Missing(I)=0
		PptDays(I)=0
             NDays=0
		 ValidN(I)=0	   		 
	DO K=1, NumberLines
	       IF (Date_Str(I)==DataDate(K)(1:5) .AND. DataOut(K)==-99) Missing(I)=Missing(I)+1
	   	   IF (Date_Str(I)==DataDate(K)(1:5) .AND. DataOut(K) .NE. -99) THEN   
	                    Sum=Sum+DataOut(K)					  
			 Sum_of_Squares=Sum_of_Squares+DataOut(K)**2
		              NDays=NDays+1
				  ValidN(I)=NDays
					  IF (DataOut(K)>0) PptDays(I)=PptDays(I)+1
					  IF (DataOut(K)>Maximum(I)) Maximum(I)=DataOut(K)
					  IF (DataOut(K)<Minimum(I)) Minimum(I)=DataOut(K)				     				  
	       END IF
	END DO	 
  IF (NDays>=2) Avg(I)=Sum/NDays ! More Than 1 Year
  IF (NDays==1) Avg(I)=Sum ! 1 year
  IF (NDays-1==0) StdDev(I)=-99
  IF ((Sum_of_Squares-(Sum**2/NDays))/NDays-1>=0) THEN                                                         
     StdDev(I)=SQRT((Sum_of_Squares-(Sum**2/NDays))/(NDays-1))
	 
  ELSE
     StdDev(I)=0
END IF
! write(*,*) Date_Str(I), Avg(I), StdDev(I), Minimum(I), Maximum(I), ValidN(I), Missing(I)
END DO 
!
END SUBROUTINE DayStatistics ! ******************************************************************
!
!
SUBROUTINE PptOutput ! **************************************************************************
IMPLICIT NONE
!
OPEN(UNIT=10, FILE=FileNameOut, STATUS="NEW", ACTION="WRITE", POSITION="REWIND", &
		IOSTAT=OpenStatus)
	IF (OpenStatus>0) STOP "Cannot Open File"

WRITE (UNIT=10, FMT=80) "Beginning Date is ", BeginDate
WRITE (UNIT=10, FMT=90) "   Ending Date is ", EndDate
80 FORMAT(A18, A10)
90 FORMAT(A18, A10)

IF (PositionPpt>0) WRITE (UNIT=10, FMT=100) "Date", "Day", "Avg", "Max", &
                  & "PptDays", "ValidN", "Missing"
	
IF (PositionSnw>0) WRITE (UNIT=10, FMT=100) "Date", "Day", "Avg", "Max", & 
                  & "SnwDays", "ValidN", "Missing"

100 FORMAT(X, A4, 2X, A3, 6X, A3, 7X, A3, 2X, A7, X, A6, 2X, A7)

DO I=1,366
	WRITE (UNIT=10,FMT=110) Date_Str(I),I, Avg(I),Maximum(I), PptDays(I), &
	& ValidN(I), Missing(I)	
END DO
110 FORMAT (X, A5, 2X, I3, 2X, F9.4, 2X, F6.1, 2X, I4, 4X, I3, 5X, I3) 
CLOSE (UNIT=10)

END SUBROUTINE PptOutput
!
!
SUBROUTINE TemperatureOutput ! ********************************************************************
IMPLICIT NONE
!
OPEN(UNIT=10, FILE=FileNameOut, STATUS="NEW", ACTION="WRITE", POSITION="REWIND", &
		IOSTAT=OpenStatus)
	IF (OpenStatus>0) STOP "Cannot Open File"

WRITE (UNIT=10, FMT=80) "Beginning Date is ", BeginDate
WRITE (UNIT=10, FMT=90) "   Ending Date is ", EndDate
80 FORMAT(A18, A10)
90 FORMAT(A18, A10)

WRITE (UNIT=10, FMT=120) "Date", "Day", "Avg", "StdDev", "Min", "Max", &
      & "ValidN", "Missing"
120 FORMAT (X, A4, 2X, A3, 6X, A3, 6X, A6, 5X, A3, 5X, A3, 2X, A6, X, &
      & A7)

DO I=1, 366
    WRITE(UNIT=10, FMT=130) Date_Str(I), I, Avg(I), StdDev(I), Minimum(I), &
	& Maximum(I), ValidN(I), Missing(I)
END DO
130 FORMAT(X, A5, 2X, I3, 2X, F9.4, 2X, F7.4, 2X, F6.1, 2X, F6.1, 2X, &
      & I4, 2X, I4)
	 
CLOSE (UNIT=10)
END SUBROUTINE TemperatureOutput ! ****************************************************************
!
!
SUBROUTINE QwOutput ! *****************************************************************************
IMPLICIT NONE
!
OPEN(UNIT=10, FILE=FileNameOut, STATUS="NEW", ACTION="WRITE", POSITION="REWIND", &
		IOSTAT=OpenStatus)
	IF (OpenStatus>0) STOP "Cannot Open File"

WRITE (UNIT=10, FMT=80) "Beginning Date is ", BeginDate
WRITE (UNIT=10, FMT=90) "   Ending Date is ", EndDate
80 FORMAT(A18, A10)
90 FORMAT(A18, A10)

WRITE (UNIT=10, FMT=140) "Date", "Day", "Avg", "Min", "Max", "QDays", "ValidN", "Missing"
140 FORMAT(X, A4, 2X, A3, 8X, A3, 9X, A3, 8X, A3, 4X, A5, X, A6, X, &
      & A7)

DO I=1, 366
    WRITE(UNIT=10, FMT=150) Date_Str(I), I, Avg(I), Minimum(I), Maximum(I), PptDays(I), &
	& ValidN(I), Missing(I)
END DO
150 FORMAT(X, A5, 2X, I3, 3X, F11.4, X, F9.2, X, F11.2, 2X, I3, 4X, &
      & I3, 3X, I3)

CLOSE (UNIT=10)
END SUBROUTINE QwOutput ! *************************************************************************


END PROGRAM AnnualCycle_v2 ! *************************************************************************
