! Program Processes NCDC CR/LF ASCII Files
! Requires .crd file exported from EarthInfo CD ROM.
! Or NCDC CR/LF files of only one data type (e.g., ppt, snw, mint, maxt)
! Returns Data in Character Array MM/DD/YYYY XXX  
! June 10, 1997
! August 30, 2005
! This is Verson 4 of NCDC_CR_LF.exe, which allows for missing lines
! or years in NCDC data. This version supercedes NCDC_v3. Version 4 uses
! leap year modifications from version 3.
! January 25, 2006 FileNameIn and FileNameOut increased to *120
! April 5, 2006 Added line 104 to trap " 99999 " and " 99999S" precipitation flags
! which are set to 0    
!
!****************************************************************************************
!
PROGRAM NCDC_v4

IMPLICIT NONE

CHARACTER (403) :: NCDC_DAT (1800)  !Character array NCDC_DAT of length 403 with 1800 lines
 CHARACTER (14) :: Date_Data(54788)	!Output character array, 54,788 days in 150 years

      CHARACTER :: Date*10, Day*2, DayData*3, FileNameIn*120, FileNameOut*120, FirstYear_Str*4, &
			LastYear_Str*4, Mth*2, MthDays_Str*2, Response*1, TempDayData*7, Year*4
      CHARACTER :: Day_Str*2, TempDateData*14

        INTEGER :: I,  J,  K, LinesOut, MthNumber, YearNumber, NumberLines_NCDC, &
			OpenStatus, InputStatus
        INTEGER :: Day_No, FirstYear, LastYear, Months, MthDays, Number_of_Days  
!															   
! Data Entry and File Names
!
 Input_Loop: DO
    WRITE (*,*) 
 20 WRITE (*,*) "Enter Name of Data File to Process"
    WRITE (*,*) 
		READ(*,*) FileNameIn
	WRITE (*,*)

OPEN (UNIT=10,FILE=FileNameIn, STATUS="OLD", ACTION="READ", POSITION ="REWIND", &
		ERR=20, IOSTAT=OpenStatus)		
		  
	WRITE (*,*) "Enter Output File Name"
	WRITE (*,*) 
 		READ (*,*) FileNameOut
!	 
! Read Input NCDC Data File into Array NCDC_DAT
!
NumberLines_NCDC=0
!
ReadFile:DO I=1,1800 
READ (UNIT=10,FMT=100, IOSTAT=InputStatus) NCDC_DAT (I)
	FirstYear_Str=NCDC_DAT(1)(18:21) 
	IF (InputStatus > 0) STOP "Input Error"
		IF (InputStatus < 0) EXIT !"End of File"
100 FORMAT (A403)
	NumberLines_NCDC=NumberLines_NCDC+1
END DO ReadFile
LastYear_Str=NCDC_DAT(NumberLines_NCDC-1)(18:21)
CLOSE (UNIT=10, STATUS="KEEP")
! 
READ (FirstYear_Str,*) FirstYear
READ (LastYear_Str,*) LastYear
!
OPEN (UNIT=10, FILE=FileNameOut, STATUS="NEW",ACTION="WRITE", POSITION="REWIND", &
		IOSTAT=OpenStatus)
	IF (OpenStatus > 0) STOP "Cannot Open File"
!
! Process array NCDC_DAT to extract calendar date and data in form MM/DD/YYYY XXX
! 
LinesOut=0
!
ReadLines: DO I=1,NumberLines_NCDC
	Year=NCDC_DAT (I)(18:21)
	 Mth=NCDC_DAT (I)(22:23)
	 READ(Year, *) YearNumber !Convert string to integer
	 READ(Mth, *) MthNumber
!	     
! Select number of days in month--MthDays_Str
!					
	   Days_in_Month: SELECT CASE (Mth)
	    CASE("02")
		MthDays_Str="28"
          IF (MOD(YearNumber,4)==0 .AND. MOD(YearNumber,100) .NE. 0) MthDays_Str="29" !Leap Year 
		  IF (MOD(YearNumber,400)==0) MthDays_Str="29" !Leap Year Exception 		
		CASE ("04")
			MthDays_Str="30"
		CASE ("06")
			MthDays_Str="30"
		CASE ("09")
			MthDays_Str="30"
		CASE ("11")
			MthDays_Str="30"
		CASE DEFAULT
			MthDays_Str="31"
	END SELECT Days_in_Month
!
! Read a line of data and format output
!	
		Extract_Data:DO K=35,403,12			 			 
		   	TempDayData=NCDC_DAT(I)(K:K+7)
			        Day=NCDC_DAT(I)(K-4:K-3)			
			DayData=TempDayData (4:6)
			IF (TempDayData(1:7)=="-99999M") DayData(1:3)="-99"
			IF (TempDayData(1:7)==" 99999 ") DayData(1:3)="  0"
			IF (TempDayData(1:7)==" 99999S") DayData(1:3)="  0"					
			IF (TempDayData(1:7)==" 00000T") DayData(1:3)="  T"					
			IF (TempDayData(1:7)==" 00000 ") DayData(1:3)="  0"
			IF (DayData(1:3) .NE. "-99" .AND. TempDayData(1:5)=="-0000") & !Minus sign temp. data
			 DayData(1:3)=" -"//TempDayData(6:6)
			IF (DayData(1:3) .NE. "-99" .AND. TempDayData(1:4)=="-000") &  ! ibid.
			 DayData(1:3)="-"//TempDayData(5:6)
			IF (IACHAR(DayData(2:2))==48 .AND. DayData (1:1)=="-") &	   !Remove leading 0's
			 DayData(1:3)=" "//DayData(1:1)//DayData(3:3)
			IF (IACHAR(DayData(1:1))==48 .AND. IACHAR(DayData(2:2))==48) & ! ibid.
			 DayData(1:2)="  "
			IF (IACHAR(DayData(1:1))==48) DayData(1:1)=" "				   ! ibid.
		Date=Mth//"/"//Day//"/"//Year		
		LinesOut=LinesOut+1	! Count number of lines output
		WRITE (UNIT=10, FMT=300) Date,DayData !Write data to file
		300 FORMAT (A10,X,A3)
			IF (Day==MthDays_Str) EXIT 	
		END DO Extract_Data
END DO ReadLines
!
CLOSE (UNIT=10)

Months=(LastYear-FirstYear+1)*12
IF (NumberLines_NCDC==Months) GOTO 400
!
! Check missing lines in NCDC data.
! Create full set of calendar dates in the form MM/DD/YYYY -99 from BeginYear to
! EndYear. These dates are compared with those from NCDC data.
!
Number_of_Days=0
!
DO I=FirstYear, LastYear
	WRITE (Year,'(I4)') I
		DO J=1,12
		  WRITE (Mth,'(I2)') J
		    IF (J<10) Mth(1:1)="0"
		!Select number of days in month J
		SELECT CASE (J)
		CASE (2)
        MthDays=28
          IF (MOD(I,4)==0 .AND. MOD(I,100) .NE. 0) MthDays=29 !Leap Year 
		  IF (MOD(I,400)==0) MthDays=29 !Leap Year Exception 
		CASE (4)
			MthDays=30
		CASE (6)
			MthDays=30
		CASE (9)
			MthDays=30
		CASE (11)
			MthDays=30
		CASE DEFAULT
			MthDays=31
		END SELECT
		
				 	DO Day_No=1, MthDays
						Number_of_Days=Number_of_Days+1
						WRITE (Day_Str,'(I2)') Day_No
							IF (Day_No<10) Day_Str(1:1)="0"
						Date_Data(Number_of_Days)(1:14)=Mth//"/"//Day_Str &
								//"/"//Year//" -99"
					END DO
		END DO
END DO
!
! Compare calendar dates in Date_Data with TempDateData and
! place data in Date_Data, save Date_Data as FileNameIn
!
OPEN (UNIT=10, FILE=FileNameOut, POSITION="REWIND")
READ (UNIT=10, FMT=200) TempDateData
!
DO I=1, Number_of_Days	
	IF (Date_Data(I)(1:10)==TempDateData(1:10)) THEN 
		Date_Data(I)(11:14)=TempDateData(11:14)
 		READ (UNIT=10,FMT=200, IOSTAT=InputStatus) TempDateData
			IF (InputStatus<0) EXIT !End of File
		END IF
END DO
!
CLOSE (UNIT=10, STATUS="DELETE")
!
OPEN (UNIT=10, FILE=FileNameOut, POSITION="REWIND", ACTION="WRITE", STATUS="NEW")

DO I=1, Number_of_Days
	WRITE (UNIT=10,FMT=200) Date_Data(I)
END DO
!
CLOSE (UNIT=10,STATUS="KEEP")
!
200 FORMAT (A14)
!
IF (NumberLines_NCDC<Months) GOTO 500
!
! Display file information
!
400     WRITE (*,*)
		WRITE (*,*) "Finished Processing File ", TRIM (FileNameIn)
		WRITE (*,*)
		WRITE (*,*) "Created File ", TRIM (FileNameOut)
		WRITE (*,*)
		WRITE (*,*) "Number of Months = ", NumberLines_NCDC
		WRITE (*,*) 
		WRITE (*,*) "Number of Days in File = ", LinesOut
		WRITE (*,*)

GOTO 600

500     WRITE (*,*)
        WRITE (*,*) "Finished Processing File ", TRIM (FileNameIn)
		WRITE (*,*)
		WRITE (*,*) "Created File ", TRIM (FileNameOut)
		WRITE (*,*)
		WRITE (*,*) "Number of Months (Unadjusted) = ", NumberLines_NCDC
		WRITE (*,*) 
		WRITE (*,*) "Number of Days in File (Adjusted) = ", Number_of_Days
		WRITE (*,*)
		WRITE (*,*) "Note: Lines Are Missing in NCDC File--Adjusted"
		WRITE (*,*)      
!
600 WRITE (*,*) "Process Another Data File? (Y or N)"
    WRITE (*,*)
	READ (*,*) Response
		IF (Response=="N") EXIT
		IF (Response=="n") EXIT
!
END DO Input_Loop
!
! ************************************************************************************
!
END PROGRAM NCDC_v4 