! SetUpTable_v1.1.f90
! September 7, 2005
! December 8, 2005 Modified to Read Single and Consecutive Days
! Program Reads Files Output by Day_Cli_Ann_v5.3
! Input is the Output Column (cols. 26-50) of Day_Cli_Ann_v5.3
! Ouput File is Date Registered Table of Selected Column  
! File Name Must Include ppt, snw, qw, tmin, or tmax
! snw, tmin, and tmax implemented but not debugged
!
PROGRAM SetUpTable_v1_1
IMPLICIT NONE

CHARACTER :: FileNameOut*120
CHARACTER :: FileNameIn (200)*120
CHARACTER :: Answer1*1, Answer2*1, DataType*4, Temp*200
CHARACTER :: BatchFileName*120, BatchFileIn*120, &
			 & DirectoryIn*120, DirectoryOut*120

  INTEGER :: DataColumn, OpenStatus, OpenStatus1, InputStatus,InputStatus1, & 
				& NumberLines, BatchFileNumber 
  INTEGER :: I, J, K
  INTEGER :: FilePosition, NoIntervals, PositionPpt, PositionTxt, PositionSnw, &
				& PositionQw, PositionTmin, PositionTmax, FirstYear, LastYear     
  INTEGER :: Days_GTQ3(200), Days_GT90(200),  Days_LTE90(200), ConsecDay(200), Single(200) 
     REAL :: Avg(200), AvgTempDev(200), Ppt_GT95(200), Ppt_GT90(200), Ppt_LTE90(200), &
	         & Ppt_GTE100(200), Total(200)
	 REAL :: Maximum(200), Minimum(200), XPosition(200)
  INTEGER :: Days_GT95(200), Days_GTE99(200), Days_GTE100(200), Missing(200), ZeroDays(200)

     REAL, DIMENSION (:,:), ALLOCATABLE :: OutputTable 
!
! User Input ********************************************************************************
!
! File Input for Batch Processing 
!
1 WRITE (*,*) "Enter path and name of batch processing file"
		READ (*,*) BatchFileName
		WRITE(*,*)
!WRITE (*,*) "Enter number of files to process"
		!READ (*,*) BatchFileNumber
		!WRITE(*,*)
WRITE (*,*) "Enter drive letter and directory of input files"
		READ (*,*) DirectoryIn 
		WRITE(*,*)
WRITE (*,*) "Enter drive letter and directory of output file"
		READ (*,*) DirectoryOut
		WRITE(*,*)
!
WRITE (*, *) "Enter First and Last Year of Output Table (i.e., 1900, 2000)"
WRITE (*, *) "Must Include Earliest and Latest Year of Input Files"
WRITE (*, *) 
 READ (*, *) FirstYear, LastYear
!
Answer2="Y" ! Intial Condition
!
OPEN (UNIT=11,FILE=BatchFileName, STATUS="OLD", POSITION="REWIND", &
         ERR=1, IOSTAT=OpenStatus1)
!
BatchFileNumber=0
DO J=1, 200 
READ (UNIT=11, FMT=10,IOSTAT=InputStatus1) Temp
	IF (InputStatus1 > 0) STOP "Input Error"
			IF (InputStatus1 < 0) EXIT !"End of File"
			BatchFileNumber=BatchFileNumber+1
END DO
!
REWIND (UNIT=11)
!
ALLOCATE (OutputTable(FirstYear:LastYear, 1:BatchFileNumber+1))
!
        DO J=FirstYear, Lastyear ! First Column is Year
		     OutputTable(J,1)=J
	    END DO
		OutputTable(FirstYear:LastYear, 2:BatchFileNumber+1)=-99 ! Set OutputTable to -99 
!
15 OPEN (UNIT=11,FILE=BatchFileName, STATUS="OLD", POSITION="REWIND", &
         ERR=1, IOSTAT=OpenStatus1)
!

!
Batch_Input_Loop:DO J=1, BatchFileNumber
!
     READ (UNIT=11, FMT=10,IOSTAT=InputStatus1) Temp !BatchFileIn
	        BatchFileIn(1:26)=Temp(26:50)
		IF (InputStatus1 > 0) STOP "Input Error"
			IF (InputStatus1 < 0) EXIT !"End of File"
	10 FORMAT (A)
	 FileNameIn(J)=TRIM(DirectoryIn)//"\"//BatchFileIn	
		
        PositionPpt=INDEX (FileNameIn(J), "ppt")
        PositionSnw=INDEX (FileNameIn(J), "snw")
         PositionQw=INDEX (FileNameIn(J), "qw")
	   PositionTmin=INDEX (FileNameIn(J), "tmin")
	   PositionTmax=INDEX (FileNameIn(J), "tmax")
!
               IF (PositionPpt>0) DataType="ppt"
               IF (PositionSnw>0) DataType="snw"
	            IF (PositionQw>0) DataType="qw"
	          IF (PositionTmin>0) DataType="tmin"
	          IF (PositionTmax>0) DataType="tmax"
!
		! Select Type Of Data For Output
		IF (J==1 .AND. Answer2=="Y" .OR. Answer2=="y") THEN 
			CALL SelectDataType
			WRITE (*,*)
			WRITE (*,*) "Enter name of output table"
				READ (*,*) FileNameOut
			FileNameOut=TRIM(DirectoryOut)//"\"//FileNameOut
			WRITE (*,*)
		END IF
!
CALL ReadInputFile ! ******************************************************************************
!
                         IF (DataType=="ppt") CALL PptFile
                         IF (DataType=="snw") CALL SnwFile
                          IF (DataType=="qw") CALL QwFile 
  IF (DataType=="tmin" .OR. DataType=="tmax") CALL TemperatureFile
!
CALL AddColumn
!
CLOSE (Unit=10)
!
END DO Batch_Input_Loop ! *************************************************************************
!
CALL FileOutput
!
CLOSE (UNIT=11)
!
! *********************************** Continue Data Output *****************************************
!
12	WRITE (*,*) "Process Another Type of Data Column From This File Y/N"
		READ (*,*) Answer1
		IF (Answer1=="Y".OR. Answer1=="y") THEN 
			Call SelectDataType
			WRITE (*, *)
			WRITE (*, *) "Enter name of output table"
				READ (*, *) FileNameOut
					FileNameOut=TRIM(DirectoryOut)//"\"//FileNameOut
				Answer2="N"					
			GOTO 15 		
		END IF
		WRITE(*,*)
	WRITE (*,*) "Process Another Batch File Y/N"
	WRITE (*, *)
		READ (*,*) Answer2 
		IF (Answer2=="Y" .OR. Answer2=="y") THEN
	       DEALLOCATE(OutputTable)
		   GOTO 1
		END IF	       
!
! *************************************************************************************************
!
                                         CONTAINS
!
SUBROUTINE ReadInputFile ! ************************************************************************
IMPLICIT NONE
!
NumberLines=0
OPEN (UNIT=10,FILE=FileNameIn(J), STATUS="OLD", ACTION="READ",POSITION="REWIND", &
IOSTAT=OpenStatus)
	IF (OpenStatus > 0) STOP "Cannot Open File (1)"                
                 DO I=1, 200 ! Count Lines in File
                    READ (10,*, IOSTAT=InputStatus) Temp
				   	   IF (InputStatus < 0) EXIT !End of File
                    NumberLines=NumberLines+1
                 END DO
REWIND (Unit=10)
IF (DataType=="ppt" .OR. DataType=="snw" .OR. DataType=="tmax" .OR. DataType=="tmin") THEN 
       NoIntervals=NumberLines-11
	  FilePosition=11
END IF
!
IF (DataType=="qw") THEN
       NoIntervals=NumberLines-12
	  FilePosition=12
END IF 
! Position File Pointer At Row 11 For ppt, snw, tmin, and tmax; Row 12 for qw
                 DO I=1,FilePosition
                    READ (10,*) Temp 
                 END DO
!
END SUBROUTINE ReadInputFile ! ******************************************************************* 
!
SUBROUTINE PptFile ! *****************************************************************************
IMPLICIT NONE
!
DO I=1, NoIntervals
	READ(Unit=10, FMT=110) XPosition(I), Total(I), Minimum(I), Maximum(I), & 
	Days_GT90(I), Ppt_GT90(I), Days_LTE90(I), Ppt_LTE90(I), Days_GT95(I), Ppt_GT95(I), &
	& Days_GTE100(I), Ppt_GTE100(I), ZeroDays(I), Missing(I), Single(I), ConsecDay(I)
END DO
!
110 FORMAT(X, F6.1, 2X, F7.1, 2X, F7.1, 2X, F7.1, 2X, I4, 2X, F7.1, 3X, I4, 4X, F7.1, &
    & 2X, I4, 4X, F7.1, 3X, I4, 5X, F7.1, 4X, I4, 4X, I4, 4X, I4, 5X, I4)
!
END SUBROUTINE PptFile ! **************************************************************************
!
SUBROUTINE SnwFile ! ******************************************************************************
IMPLICIT NONE
!
DO I=1, NoIntervals
	READ(Unit=10, FMT=130) XPosition(I), Total(I), Minimum(I), Maximum(I), Days_GT90(I), & 
	& Ppt_GT90(I), Days_LTE90(I), Ppt_LTE90(I), Days_GT95(I), Ppt_GT95(I), &
	& ZeroDays(I), Missing(I), Single(I), ConsecDay(I)
END DO
130 FORMAT(X, F7.1, 2X, F7.1, 2X, F7.1, 2X,F7.1, 2X, I4, 2X, F7.1, 3X, I4, 4X, &
    & F7.1, 2X, I4, 4X, F7.1, 2X, I4, 4X, I4, 4X, I4, 6X, I4)
!
END SUBROUTINE SnwFile ! **************************************************************************
!
SUBROUTINE QwFile ! *******************************************************************************
IMPLICIT NONE
!
DO I=1, NoIntervals
	READ(Unit=10, FMT=150) XPosition(I), Avg(I), Minimum(I), Maximum(I), Days_GT90(I), &
	& Days_LTE90(I), Days_GT95(I), Days_GTE99(I), ZeroDays(I), Missing(I), Single(I), ConsecDay(I)
END DO
150  FORMAT(X, F6.1, 2X, F10.3, 2X, F8.2, 2X, F8.1, 2X, I4, 4X, I4, &
      & 4X, I4, 5X, I4, 5X, I4, 4X, I4, 5X, I4, 6X, I4)
END SUBROUTINE QwFile ! ***************************************************************************
!
SUBROUTINE TemperatureFile ! **********************************************************************
IMPLICIT NONE
!
DO I=1, NoIntervals
    READ (Unit=10, FMT=130), XPosition(I), Avg(I), Minimum(I), Maximum(I), Days_GTQ3(I), &
	& Days_GT90(I), Days_GT95(I), AvgTempDev(I), Missing(I), Single(I), ConsecDay(I)
END DO
130 FORMAT(X, F6.1, 4X, F8.4, 3X, F6.2, 3X, F6.2, 3X, I4, 3X, I4, 5X, I4, 4X, F8.4, 3X, I4, 5X, I4, 6X, I4)
!
END SUBROUTINE TemperatureFile ! ******************************************************************
!
SUBROUTINE AddColumn ! *************************************************************************
IMPLICIT NONE
!
IF (DataType=="ppt") THEN 
	SELECT CASE (DataColumn)
	    CASE (2) ! Total Precipitation
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Total(1:NoIntervals)
		CASE (3) ! Minimum Precipitation >0
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Minimum(1:NoIntervals)
		CASE (4) ! Maximum Precipitation
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Maximum(1:NoIntervals)
		CASE (5) ! Days With Precipitation > 90th Percentile
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Days_GT90(1:NoIntervals)
		CASE (6) ! Precipitation > 90th Percentile
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Ppt_GT90(1:NoIntervals)
		CASE (7) ! Days <= 90th Percentile
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Days_LTE90(1:NoIntervals)
		CASE (8) ! Precipitation <= 90 Percentile
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Ppt_LTE90(1:NoIntervals)
		CASE (9) ! Days > 95th Percentile
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Days_GT95(1:NoIntervals)
		CASE (10) ! Precipitation > 95th Percentile
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Ppt_GT95(1:NoIntervals)
		CASE (11) ! Days >= 1 Inch
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Days_GTE100(1:NoIntervals)
		CASE (12) ! Precipitation >= 1 inch
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Ppt_GTE100(1:NoIntervals)
		CASE (13) ! Days Without Precipitation
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=ZeroDays(1:NoIntervals)
		CASE (14) ! Days With Missing Data
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Missing(1:NoIntervals)
		CASE (15) ! Single Days > Threshold
        OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Single(1:NoIntervals)
		CASE (16) ! Consecutive Days > Threshold
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=ConsecDay(1:NoIntervals)
	END SELECT
END IF
!
IF (DataType=="snw") THEN
SELECT CASE (DataColumn)
	    CASE (2) ! Total Snowfall
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Total(1:NoIntervals)
		CASE (3) ! Minimum Snowfall >0
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Minimum(1:NoIntervals)
		CASE (4) ! Maximum Snowfall
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Maximum(1:NoIntervals)
		CASE (5) ! Days With Snowfall > 90th Percentile
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Days_GT90(1:NoIntervals)
		CASE (6) ! Snowfall > 90th Percentile
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Ppt_GT90(1:NoIntervals)
		CASE (7) ! Days <= 90th Percentile
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Days_LTE90(1:NoIntervals)
		CASE (8) ! Snowfall <= 90 Percentile
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Ppt_LTE90(1:NoIntervals)
		CASE (9) ! Days > 95th Percentile
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Days_GT95(1:NoIntervals)
		CASE (10) ! Snowfall > 95th Percentile
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Ppt_GT95(1:NoIntervals)
		CASE (11) ! Days Without Snowfall
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=ZeroDays(1:NoIntervals)
		CASE (12) ! Days With Missing Data
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Missing(1:NoIntervals)
		CASE (13) ! Single Days > Threshold
        OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Single(1:NoIntervals)
		CASE (14) ! Consecutive Days > Threshold
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=ConsecDay(1:NoIntervals)
	END SELECT
END IF
!
IF (DataType=="qw") THEN
SELECT CASE (DataColumn)
	   	CASE (2) ! Average Daily Discharge
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Avg(1:NoIntervals)
		CASE (3) ! Minimum Discharge >0
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Minimum(1:NoIntervals)
		CASE (4) ! Maximum Discharge
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Maximum(1:NoIntervals)
		CASE (5) ! Days With Discharge > 90th Percentile
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Days_GT90(1:NoIntervals)
		CASE (6) ! Days <= 90th Percentile
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Days_LTE90(1:NoIntervals)
		CASE (7) ! Days > 95th Percentile
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Days_GT95(1:NoIntervals)
		CASE (8) ! Days >= 99th Percentile
               	OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Days_GTE99(1:NoIntervals)
		CASE (9) ! Days With No Discharge
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=ZeroDays(1:NoIntervals)
		CASE (10) ! Days With Missing Data
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Missing(1:NoIntervals)
		CASE (11) ! Single Days > Threshold
        OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Single(1:NoIntervals)
		CASE (12) ! Consecutive Days > Threshold
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=ConsecDay(1:NoIntervals)
	END SELECT
END IF
!
IF (DataType=="tmin" .OR. DataType=="tmax") THEN
SELECT CASE (DataColumn)
	   	CASE (2) ! Average Daily Temperature
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Avg(1:NoIntervals)
		CASE (3) ! Minimum Temperature >0
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Minimum(1:NoIntervals)
		CASE (4) ! Maximum Temperature
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Maximum(1:NoIntervals)
		CASE (5) ! Days With Temperature > 90th Percentile
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Days_GTQ3(1:NoIntervals)
		CASE (6) ! Days > 90th Percentile
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Days_GT90(1:NoIntervals)
		CASE (7) ! Days > 95th Percentile
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Days_GT95(1:NoIntervals)
		CASE (8) ! Average Deviation From Mean Daily Temperature
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=AvgTempDev(1:NoIntervals)
		CASE (9) !Days With Missing Data
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Missing(1:NoIntervals)
		CASE (10) ! Single Days > Threshold
        OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=Single(1:NoIntervals)
		CASE (11) ! Consecutive Days > Threshold
		OutputTable(XPosition(1):XPosition(NoIntervals),J+1)=ConsecDay(1:NoIntervals)
	END SELECT
END IF
!
END SUBROUTINE AddColumn ! *********************************************************************
!
SUBROUTINE SelectDataType ! ***********************************************************************
!
IF (DataType=="ppt") THEN
			WRITE (*,*)
			WRITE (*,*) "Select Type Of Precipitation Data to Output"
			WRITE (*,*) "_____________________________"
			WRITE (*,*)
			WRITE (*,*) "(...) Year"
			WRITE (*,*) " 1 = Total Precipitation"
			WRITE (*,*) " 2 = Minimum Precipitation > 0"
			WRITE (*,*) " 3 = Maximum Precipitation"
			WRITE (*,*) " 4 = Days With Precipitation > 90th Percentile"
			WRITE (*,*) " 5 = Precipitation > 90 Percentile"
			WRITE (*,*) " 6 = Days <= 90th Percentile"
			WRITE (*,*) " 7 = Precipitation <= 90th Percentile"
			WRITE (*,*) " 8 = Days > 95th Percentile"
			WRITE (*,*) " 9 = Precipitation > 95th Percentile"
			WRITE (*,*) "10 = Days >= 1 inch"
			WRITE (*,*) "11 = Precipitation >= 1 inch"
			WRITE (*,*) "12 = Days Without Precipitation"
			WRITE (*,*) "13 = Days with Missing Data"
			WRITE (*,*) "14 = Single Days > Threshold"
			WRITE (*,*) "15 = Consecutive Days > Threshold"
			WRITE (*,*)
			WRITE (*,*) "______________________________"
			WRITE (*,*)
			WRITE (*,*) "Enter Number of Data for Output"
			WRITE (*, *)
		READ (*,*)  DataColumn
END IF
!
IF (DataType=="snw") THEN
			WRITE (*,*)
			WRITE (*,*) "Select Type Of Snowfall Data to Output"
			WRITE (*,*) "______________________________________"
			WRITE (*,*)
			WRITE (*,*) "(...) Year"
			WRITE (*,*) " 1 = Total Snowfall"
			WRITE (*,*) " 2 = Minimum Snowfall > 0"
			WRITE (*,*) " 3 = Maximum Snowfall"
			WRITE (*,*) " 4 = Days With Snowfall > 90th Percentile"
			WRITE (*,*) " 5 = Snowfall > 90th Percentile"
			WRITE (*,*) " 6 = Days <= 90th Percentile"
			WRITE (*,*) " 7 = Snowfall <= 90th Percentile"
			WRITE (*,*) " 8 = Days > 95th Percentile"
			WRITE (*,*) " 9 = Snowfall > 95th Percentile"
			WRITE (*,*) "10 = Days Without Snowfall"
			WRITE (*,*) "11 = Days with Missing Data"
			WRITE (*,*) "12 = Single Days > Threshold"
			WRITE (*,*) "13 = Consecutive Days > Threshold"
			WRITE (*,*)
			WRITE (*,*) "______________________________________"
			WRITE (*,*)
			WRITE (*,*) "Enter Number of Data for Output"
			WRITE (*, *)
		READ (*,*)  DataColumn
END IF     
!
IF (DataType=="qw") THEN
			WRITE (*,*)
			WRITE (*,*) "Select Type Of Discharge Data to Output"
			WRITE (*,*) "_______________________________________"
			WRITE (*,*)
			WRITE (*,*) "(...) Year"
			WRITE (*,*) " 1 = Average Daily Discharge"
			WRITE (*,*) " 2 = Minimum Discharge > 0"
			WRITE (*,*) " 3 = Maximum Discharge"
			WRITE (*,*) " 4 = Days With Discharge > 90th Percentile"
			WRITE (*,*) " 5 = Days <= 90th Percentile"
			WRITE (*,*) " 6 = Days > 95th Percentile"
			WRITE (*,*) " 7 = Days >= 99th Percentile"
			WRITE (*,*) " 8 = Days Without Discharge"
			WRITE (*,*) " 9 = Days with Missing Data"
			WRITE (*,*) "10 = Single Days > Threshold"
			WRITE (*,*) "11 = Consecutive Days > Threshold"
			WRITE (*,*)
			WRITE (*,*) "_______________________________________"
			WRITE (*,*)
			WRITE (*,*) "Enter Number of Data for Output"
			WRITE (*, *)
		READ (*,*)  DataColumn
END IF
!
IF (DataType=="tmin" .OR. DataType=="tmax") THEN
			WRITE (*,*)
			WRITE (*,*) "Select Type Of Temperature Data to Output"
			WRITE (*,*) "_________________________________________"
			WRITE (*,*)
			WRITE (*,*) "(...) Year"
			WRITE (*,*) " 1 = Average Daily Temperature"
			WRITE (*,*) " 2 = Minimum Temperature"
			WRITE (*,*) " 3 = Maximum Temperature"
			WRITE (*,*) " 4 = Days > 75th Percentile"
			WRITE (*,*) " 5 = Days > 90th Percentile"
			WRITE (*,*) " 6 = Days > 95th Percentile"
			WRITE (*,*) " 7 = Average Deviation From Mean Daily Temperature"
			WRITE (*,*) " 8 = Days with Missing Data"
			WRITE (*,*) " 9 = Single Days > Threshold"
			WRITE (*,*) "10 = Consecutive Days > Threshold"
			WRITE (*,*)
			WRITE (*,*) "__________________________________________"
			WRITE (*,*)
			WRITE (*,*) "Enter Number of Data for Output"
			WRITE (*, *)
		READ (*,*)  DataColumn
END IF			 
!
		DataColumn=DataColumn+1 
!
END SUBROUTINE SelectDataType
!
SUBROUTINE FileOutput ! **********************************************************
IMPLICIT NONE
!
OPEN (UNIT=10,FILE=FileNameOut, STATUS="NEW", ACTION="WRITE",POSITION="REWIND", &
IOSTAT=OpenStatus)
	IF (OpenStatus > 0) STOP "Cannot Open File (2)"
!
! Write Column Headers
REWIND(UNIT=11)
DO I=1, BatchFileNumber
READ (UNIT=11, FMT=200, IOSTAT=InputStatus1) Temp !BatchFileIn	        
     IF (I==1) WRITE (UNIT=10,FMT=190, ADVANCE="NO") "Year"
		PositionTxt=INDEX(Temp(26:50), ".txt") ! Remove .txt Extension
	 IF (PositionTxt==0) WRITE(UNIT=10, FMT=200, ADVANCE="NO") TRIM(Temp(26:50))
	 IF (PositionTxt>0) WRITE(UNIT=10, FMT=200, ADVANCE="NO") TRIM(Temp(26:26+PositionTxt-2))	 
        IF (InputStatus1 < 0) EXIT !"End of File"  
END DO
!
190 FORMAT(A4, X)
200 FORMAT (A, X)
300 FORMAT(X, F12.4)
WRITE(UNIT=10, FMT=300)
!
! Write Data Columns
DO I= FirstYear, LastYear
	DO J= 1,BatchfileNumber+1
		WRITE (UNIT=10, FMT=300, ADVANCE="NO") OutputTable (I,J)
	END DO
	     WRITE(UNIT=10, FMT=300)		
END DO
!
END SUBROUTINE FileOutput ! *******************************************************


                                        END PROGRAM SetUpTable_v1_1
