! Date_Calculator_v2.f90

! Program calulates Julian Day given calendar date or a calendar
! date given the Julian Day, and the inclusive difference in days
! between to calendar dates

!Date_Calculator_v1.1.f90
!Date_Calculator_v1 Replaces Date_Calculator of 6/16/1997
!Date_Calculator_v2 Calculates Difference in Days Between Two Dates 

! 1/13/05 Program was modified to correct inconsistencies 
! in original Numerical Receipes code as suggested by Ahlquist 3/7/1999
! and Ahlquist (BMAS, 1999).
! Line ja=int(0.01*jy) in Function julday was changed to ja=jy/100
! April 15,2005 Modified to Compute Inclusive Difference Between Two
!    Calendar Dates

PROGRAM Date_Calculator_v2 ! **********************************************************************

CHARACTER :: Cal_Date*10, Month_str*2, Day_str*2, Year_str*4, Input_str*10, &
				 Answer*1, Response_str*1
INTEGER :: JulianDay, JulianDay1, JulianDay2, Mth, Day, Year, Position

Input_Loop: DO

WRITE (*,*)
WRITE (*,*) "1 = Compute a calendar date (MM/DD/YYYY) or Julian Day"
WRITE (*,*)
WRITE (*,*) "2 = Compute difference (inclusive) between two calendar dates"
WRITE (*,*)
           READ(*,*) Answer
             
	  IF (Answer=="1") THEN
		  WRITE (*,*) 
		  WRITE (*,*) "Enter a calendar date (MM/DD/YYYY) or Julian day"
		  WRITE (*,*) 
	        READ (*,FMT=10) Input_str
			10 FORMAT(A10)
		   Position=INDEX (Input_str, "/")
  	         IF (Answer=="1" .AND. Position>0) CALL Julian_Day			 
			IF (Answer=="1" .AND. Position==0) CALL Calendar_Date
	  END IF

	  IF (Answer=="2") THEN
        WRITE (*,*) 
        WRITE (*,*) "Enter the first calendar date (MM/DD/YYYY)"
		WRITE (*,*)
		    READ (*,FMT=10) Input_str
			CALL Julian_Day
			JulianDay1=JulianDay

		WRITE(*,*) "Enter the second calendar date (MM/DD/YYYY)"
		WRITE(*,*)
			 READ (*,FMT=10) Input_str
             CALL Julian_Day
			 JulianDay2=JulianDay
			 IF (JulianDay2>JulianDay1) WRITE(*,*) "Inclusive difference (days) = ", JulianDay2-JulianDay1+1
             IF (JulianDay2<JulianDay1) WRITE(*,*) "Inclusive difference (days) = ", JulianDay1-JulianDay2+1
			 IF (JulianDay2==JulianDay1) WRITE(*,*) "Inclusive difference (days) = ", 0
			 WRITE(*,*)
      END IF

WRITE (*,*) "Another Calculation ? (Y/N)"
WRITE (*,*)
READ (*,*) Response_str
IF (Response_str=="N" .OR. Response_Str=="n") EXIT

END DO Input_Loop
!
CONTAINS ! *******************************************************************************************
!
!
SUBROUTINE Julian_Day

	Cal_Date=Input_str
	CALL JulDayFormat (Cal_Date, Mth, Day, Year)
	JulianDay=julday(Mth,Day,Year)
	WRITE(*,*)
	IF (Answer=="1") WRITE (*,*)	 "Julian Day =", JulianDay
	WRITE (*,*)

END SUBROUTINE Julian_Day
!
!
SUBROUTINE Calendar_Date

READ (Input_str,*) JulianDay
	CALL caldat (JulianDay, Mth, Day, Year)
		WRITE (Month_str,'(I2)') Mth
			IF (Mth<10) Month_str(1:1)="0"
		WRITE (Day_str,'(I2)') Day
			IF (Day<10) Day_str(1:1)="0"
		WRITE (Year_str,'(I4)') Year
		WRITE (*,*)
	WRITE (*,FMT=100) "Calendar Date =",Month_str,"/", Day_str,"/", Year_str
		100 FORMAT (A16, X, A2, A1, A2, A1, A4)
	    WRITE (*,*)

END SUBROUTINE Calendar_Date
!
!
SUBROUTINE caldat(julian,mm,id,iyyy)
      INTEGER id,iyyy,julian,mm,IGREG
      PARAMETER (IGREG=2299161)
      INTEGER ja,jalpha,jb,jc,jd,je
      if(julian.ge.IGREG)then
        jalpha=int(((julian-1867216)-0.25)/36524.25)
        ja=julian+1+jalpha-int(0.25*jalpha)
      else
        ja=julian
      endif
      jb=ja+1524
      jc=int(6680.+((jb-2439870)-122.1)/365.25)
      jd=365*jc+int(0.25*jc)
      je=int((jb-jd)/30.6001)
      id=jb-jd-int(30.6001*je)
      mm=je-1
      if(mm.gt.12)mm=mm-12
      iyyy=jc-4715
      if(mm.gt.2)iyyy=iyyy-1
      if(iyyy.le.0)iyyy=iyyy-1
END SUBROUTINE caldat 
!
!
FUNCTION julday(mm,id,iyyy)

      INTEGER julday,id,iyyy,mm,IGREG
      PARAMETER (IGREG=15+31*(10+12*1582))
      INTEGER ja,jm,jy
      jy=iyyy
      if (jy.eq.0) pause 'julday: there is no year zero'
      if (jy.lt.0) jy=jy+1
      if (mm.gt.2) then
        jm=mm+1
      else
        jy=jy-1
        jm=mm+13
      endif
      julday=int(365.25*jy)+int(30.6001*jm)+id+1720995
      if (id+31*(mm+12*iyyy).ge.IGREG) then
        ja=jy/100 !ja=int(0.01*jy)
        julday=julday+2-ja+int(0.25*ja)
      endif

END FUNCTION julday
!
!
SUBROUTINE JulDayFormat(Date_Str, Mth, Day, Year)
 
CHARACTER, INTENT (IN) :: Date_Str*10
INTEGER, INTENT (OUT) :: Mth, Day, Year 
	READ (Date_Str(1:2),*) Mth
	READ (Date_Str(4:5),*) Day
	READ (Date_Str(7:10),*) Year

END SUBROUTINE JulDayFormat
!
!
END PROGRAM Date_Calculator_v2 ! **********************************************************